/*
 * test-002.c
 *		大文字からなる一行を読み込んで、小文字に変換して出力
 */

#include <stdio.h>
#include "memory.h"
#include "instruction.h"
#include "cpu.h"

/*
 * main
 */

int main( int argc, char *argv[] ) {
  int memory[MEMORY_SIZE] = {
	/* 0 */	CPU_IN,					/* acc := getchar() */
	/* 1 */	CPU_STM, 18,			/* [18] := acc */
	/* 3 */ CPU_SUB, 20,			/* acc -= '\n' */
	/* 5 */ CPU_JZ,	14,				/* if ( acc == 0 ) goto 14 */
	/* 7 */ CPU_LDM, 18,			/* acc := [18] */
	/* 9 */ CPU_SUB, 19,		/* acc -= 'A' - 'a' */
	/* 11 */	CPU_OUT,			/* putchar ( acc ) */
	/* 12 */	CPU_JUMP, 0,		/* goto 0 */
	/* 14 */	CPU_LDI,	'\n',	/* acc := '\n' */
	/* 16 */	CPU_OUT,			/* putchar ( acc ) */
	/* 17 */	CPU_HALT,			/* STOP */
	/* 18 */	0,			/* 入力したデータをここに保存 */
	/* 19 */	'A' - 'a',			/* 入力したデータをここに保存 */
	/* 20 */	'\n',			/* 入力したデータをここに保存 */
  };
  CPU cpu;
  int debug = 0;

  if ( argc > 1 && !strcmp ( argv[1], "-d" ) ) {
	debug = 1;
  }

  init_cpu ( &cpu, 0 );

  execute ( &cpu, memory, debug );

  return 0;
}

